import java.io.IOException;
import java.util.Vector;

public class SchedulabilityFramework {
	public static void main(String[] args) throws IOException{
		TaskSetFileReader myFileReader = new TaskSetFileReader();
		// you can change the name of the file to read here
		Vector<TaskSet> taskSets = myFileReader.readFile("10tasks.txt");
		// prints the first task set of the file (just to show the import works)
		printSet(taskSets.get(0));
		System.out.println();
		// would print all task sets:
		//printTaskSets(taskSets);
		LiuLaylandBound myLLB = new LiuLaylandBound();
		HyperbolicBound myHyper = new HyperbolicBound();
		Tda myTda = new Tda();
		// testing the first task set
		TaskSet ordered;
		ordered = Sorting.orderTaskSet(taskSets.get(0));
		printSet(ordered);
		System.out.println();
		myLLB.testSet(ordered);
		myHyper.testSet(ordered);
		myTda.testSetSimple(ordered);
 		myTda.testSetK2U(ordered);
 		myTda.testSetExact(ordered);
		System.out.println();
	}
	
	// prints all tasks
	private static void printTaskSets(Vector<TaskSet> taskSets){
		for(int i = 0; i < taskSets.size(); i++){
			System.out.println("Task Set Number: " + i);
			TaskSet currentSet = taskSets.get(i);
			for(int j = 0; j < currentSet.size(); j++){
				Task currentTask = currentSet.get(j);
				System.out.println(j+": Period: "+currentTask.getPeriod()+" Deadline: "+currentTask.getDeadline()+" WCET: " + currentTask.getWcet());
			}
		}
	}

	// prints one task set
	private static void printSet(TaskSet set){
		for(int j = 0; j < set.size(); j++){
			Task currentTask = set.get(j);
			System.out.println(j+": Period: "+currentTask.getPeriod()+" Deadline: "+currentTask.getDeadline()+" WCET: " + currentTask.getWcet());
		}
	}
}

