import java.io.*;
import java.util.*;
import java.util.regex.Pattern;

/*
 * Given a file with task sets, this class returns a vector of the 
 * TaskSets that are defined by the file 
 */

class TaskSetFileReader {
	TaskSetFileReader(){
	  
  }
  
  public Vector readFile(String name) throws IOException{
	   Vector<TaskSet> task_sets = new Vector<TaskSet>();
	   FileReader fr = new FileReader(name);
	   BufferedReader br = new BufferedReader(fr);
	   String line = br.readLine();
	   while(!line.equalsIgnoreCase("end")){
		   TaskSet new_set = new TaskSet();
		   while(!line.equalsIgnoreCase(";")){
			   String[] task_def = line.split(Pattern.quote(","));
			   Task new_task = new Task(Float.valueOf(task_def[0]), Float.valueOf(task_def[1]), Float.valueOf(task_def[2]));
			   new_set.addTask(new_task);
			   line = br.readLine();
		   }
		   task_sets.add(new_set);
		   line = br.readLine(); 
	   }
	   return task_sets;
  }
}
